
#    MIDAS Access Client  for the  FEBEXAccess service

package require MIDASAccessClient    ;#   load default support procedures

global MIDAS_FEBEXAccessClient_Exists
set MIDAS_FEBEXAccessClient_Exists 1

global FEBEXAccessServerHost FEBEXAccessServerPort

if {[info exists FEBEXAccessServerHost] == 0} then {set FEBEXAccessServerHost localhost}
if {[info exists FEBEXAccessServerPort] == 0} then {set FEBEXAccessServerPort 8015}

variable uri "urn:FEBEXAccessServer"
variable proxy "http://$FEBEXAccessServerHost:$FEBEXAccessServerPort/FEBEXAccessServer"

set FEBEXAccessServerTimeOut 10000

proc FEBEXAccessClient_Configure {} {
   global  FEBEXAccessServerHost FEBEXAccessServerPort
   variable proxy

   set proxy "http://$FEBEXAccessServerHost:$FEBEXAccessServerPort/FEBEXAccessServer"

   foreach method [info procs FEBEXAccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create FEBEXAccessClient__Read -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Read \
     -params {Link string Slave string Addr string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
     
SOAP::create FEBEXAccessClient__Write -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Write \
     -params {Link string Slave string Addr string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create FEBEXAccessClient__SetBit -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name SetBit \
     -params {Link string Slave string Addr string Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
     
SOAP::create FEBEXAccessClient__ClearBit -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name ClearBit \
     -params {Link string Slave string Addr string Data string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
     
SOAP::create FEBEXAccessClient__Device -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Device \
     -params {DevNum int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
     
SOAP::create FEBEXAccessClient__Reset -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Reset \
     -params {DevNum int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
 
SOAP::create FEBEXAccessClient__Init -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Init\
     -params {Link string Slave string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
     
SOAP::create FEBEXAccessClient__Configure -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Configure \
     -params {File string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 
     
SOAP::create FEBEXAccessClient__Verify -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name Verify \
     -params {File string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create FEBEXAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout $FEBEXAccessServerTimeOut \
     -name AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide FEBEXAccessClient 1.0

puts "FEBEXAccessClient provided"
