
#    Note:  This is loaded into the namespace  FEBEX_SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

global Options
global env

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0
    variable DebugFlag 0

    variable JS ""

    variable DBNameList {"xxx"}
    
    variable AcqSetOption ""
    
    global ChannelMenu
    foreach i $ChannelMenu {variable A$i; set A$i 0}
    variable A01 0
    variable A02 0
    
        variable FEBEXmodule
        variable FEBEXlink
        variable FEBEXboard
        variable FEBEXchannel
        
        variable allmodules 0
        variable alllinks 0
        variable allboards 0
    
     set ::FEBEX::DBNodeBase $env(ComputerName)


   proc show_variables {} {
        global MIDAS_DataAcquisitionControlServer_Exists
        global Options
        global ChannelMenu
        variable LogFlag
        variable ShowLogFlag
        variable AcqSetOption

        InsertLog "MIDAS_DataAcquisitionControlServer_Exists=$MIDAS_DataAcquisitionControlServer_Exists"

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "DBPath = $::FEBEX::DBRootName  $::FEBEX::DBNodeBase  $::FEBEX::DBNodeName"
        InsertLog "AcqSetOption = $AcqSetOption"

   }

    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqSetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
        }

     }
     
      proc do_Save {} {
        global Options
      
        InsertLog "Saving FEBEX settings to $::FEBEX::DBRootName/$::FEBEX::DBNodeBase/$::FEBEX::DBNodeName"
        
#        import_HardWare
        do_setopt "ParameterSave=$::FEBEX::DBNodeName"
#        export_HardWare
        
        set Options(FirmWare.Settings) $::FEBEX::DBNodeName
        
        InsertLog "Done at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        do_DBUpdate
    }

      proc do_Restore {} {
        global Options
      
        InsertLog "Restoring FEBEX settings from $::FEBEX::DBRootName/$::FEBEX::DBNodeBase/$Options(FirmWare.Settings)"
        
#        import_HardWare
        do_setopt "ParameterRestore=$Options(FirmWare.Settings)"
#        export_HardWare
         
        InsertLog "Done at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
       
        do_DBUpdate
    }
    
      proc do_DBName {vl} {
         global Options

          set ::FEBEX::DBNodeName $vl
          DBCreateNode $::FEBEX::DBRootName/$::FEBEX::DBNodeBase/$::FEBEX::DBNodeName
          set Options(FirmWare.Settings) $vl
          SaveOptions

          InsertLog "Data Base node $::FEBEX::DBRootName/$::FEBEX::DBNodeBase contains [DBGetNodes $::FEBEX::DBRootName/$::FEBEX::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::FEBEX::DBRootName/$::FEBEX::DBNodeBase *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
          if {$::FEBEX::DBNodeBase == "undefined"} {set ::FEBEX::DBNodeBase [first $DBNameList]}
      }
    
    proc do_Apply {p} {
        global ChannelMenu
        foreach i $ChannelMenu {variable A$i}

        switch -glob $p {
            A01      {foreach i $ChannelMenu {set A$i 1}}
            A02      {foreach i $ChannelMenu {set A$i 0}}
             A[0-9]   -
             A1[0-5]  {set i [string range $p 1 end]; set A$i [expr ([set A$i] + 1) & 1];}
            default  {puts "unknown"}
        }
     }
     
     proc UpdateModule {} {}

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable allmodules
        variable alllinks
        variable allboards

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]
           set i [second [lindex $cgidata 1]]
           set vl [third [lindex $cgidata 1]]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}
                
                   MODULE     {SelectFEBEXModule $i; UpdateModule}
                   ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                   LINK     {SelectFEBEXLink $i; UpdateModule}
                   ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                   BOARD     {SelectFEBEXBoard $i; UpdateModule}
                   ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}
                
                APPLY    {do_Apply [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE      {do_Restore}
                RESTORESTATE {do_RestoreState}
                SAVE         {do_Save}
                SAVESTATE    {do_SaveState}
      
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
       
       do_DBUpdate
    }

     do_DBUpdate
     LoadOptions
     
#     import_HardWare


     set html ""


}  ;# end of if {$started == 0}

